using System;
using System.Collections.Generic;

namespace ExPreloader.Runtime
{
    public class ExAssert
    {
        List<Func<bool>> _conditions = new();

        public void AddCondition(Func<bool> condition) 
            => _conditions.Add(condition);

        public bool CheckAll()
        {
            foreach (var condition in _conditions)
            {
                if (!condition())
                {
                    return false;
                }
            }
            return true;
        }

        public bool CheckAny()
        {
            foreach (var condition in _conditions)
            {
                if (condition())
                {
                    return true;
                }
            }
            return false;
        }

        public void IsNotNull(object obj)
        {
            AddCondition(() => obj != null);
        }
    
        public void IsStringNotEmpty(string str)
        {
            AddCondition(() => !string.IsNullOrEmpty(str));
        }

        public void IsTrue(bool b)
        {
            AddCondition(() => b);
        }
    }
}