using System.Collections.Generic;
using System.Net;
using Newtonsoft.Json.Linq;

namespace ExPreloader.Runtime
{
    public class UserIpData
    {
        string _url = "http://ip-api.com/json/?lang=en&fields=17023003";
        Dictionary<string, string> _userInfo;

        public void LoadUserInfo()
        {
            var info = new WebClient().DownloadString(_url);
            var parsed = JObject.Parse(info);
            _userInfo = parsed.ToObject<Dictionary<string, string>>();
        }
        
        public string GetCountryCode()
            => _userInfo["countryCode"];
        
        public string GetCountry()
            => _userInfo["country"];
        
        public string GetCity()
            => _userInfo["city"];
        
        public string GetRegion()
            => _userInfo["regionName"];
        
        public bool IsMobile()
            => _userInfo["mobile"] == "True";
        
        public bool IsProxy()
            => _userInfo["proxy"] == "True";
    }
}